package owrti;

import RTIcap.*;

/**
* Requires ObjectID, ClassID
*/
public class EvtReflectAttributeValues implements RTIEvent, RTIDebug 
{

   int ObjectID;
   RTIcap.AttributeHandleValuePair[] attribs;
   double timeStamp;
   String tag;
   RTIcap.EventRetractionHandle evtRetract;

   /**
   */
   public 
   EvtReflectAttributeValues( int _ObjectID, 
          RTIcap.AttributeHandleValuePair[] _attribs, String tag )
   {
      ObjectID = _ObjectID;
      timeStamp = -1;
      evtRetract = null;
      attribs = _attribs;
   }// end of CONSTRUCTOR
   
   /**
   */
   public 
   EvtReflectAttributeValues( int _ObjectID, 
          RTIcap.AttributeHandleValuePair[] _attribs, String _tag, 
          RTIcap.EventRetractionHandle _evtRetract, double _timeStamp)
   {
      ObjectID = _ObjectID;
      timeStamp = _timeStamp;
      evtRetract = _evtRetract;
      attribs = _attribs;
      tag = _tag;
   }// end of CONSTRUCTOR

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {

      try
      {
         
         if(timeStamp>0)
           fed.reflectAttributeValuesWithTime(ObjectID,attribs,timeStamp,tag,evtRetract);
         else 
           fed.reflectAttributeValues(ObjectID,attribs,tag);

      } catch(RTIcap.ObjectNotKnown onk) {}
        catch(RTIcap.AttributeNotKnown ank) {}
        catch(RTIcap.FederateInternalError fie) {}
        catch(RTIcap.InvalidFederationTime ift) {}
        catch(RTIcap.FederateOwnsAttributes foa) {}

   }// end of execute()

   /**
   */
   public String
   toString() 
   {  
      String ret = new String(" reflectAttributeValuesWithTime oId :"+ObjectID);
      if(attribs.length>0)
      {
         ret += " a : ";
         for(int i=0;i <attribs.length;i++) ret += (","+attribs[i]);
      }// end of if

      return ret; 

   }// end of toString()

}// end of class EvtReflectAttributeValues

